﻿using GalaSoft.MvvmLight.Command;
using Plane.Copters;
using Plane.Windows.Messages;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace Plane.FormationCreator.Formation
{
    public partial class FlightTaskSingleCopterInfo
    {
        public static FlightTaskSingleCopterInfo CreateForFlyToTask(ICopter copter, double targetLat, double targetLng, float targetAlt)
        {
            var info = new FlightTaskSingleCopterInfo(copter)
            {
                TargetLat = targetLat,
                TargetLng = targetLng,
                TargetAlt = targetAlt
            };
            return info;
        }

        public static FlightTaskSingleCopterInfo CreateForFlyToTask(ICopter copter, LatLng latLngOffset, float targetAlt, bool isLandWaypoint)
        {
            var info = new FlightTaskSingleCopterInfo(copter)
            {
                LatLngOffset = latLngOffset,
                TargetAlt = targetAlt,
                IsLandWaypoint = isLandWaypoint
            };
            return info;
        }
        
        private bool _FlytoShowLED = true;
        public bool FlytoShowLED
        {
            get { return _FlytoShowLED; }
            set { Set(nameof(FlytoShowLED), ref _FlytoShowLED, value); }
        }

        private bool _IsLandWaypoint = false;
        //降落前的航点 只有高度有效,自动飞往起飞点，写入航点的经纬为1000 飞控自动认为1000是飞往起点 by张旭东
        public bool IsLandWaypoint
        {
            get { return _IsLandWaypoint; }
            set { Set(nameof(IsLandWaypoint), ref _IsLandWaypoint, value); }
        }


        /*
         * //同一个任务每一架飞机的FlytoTime和LoiterTime保持统一,已将FlytoTime和LoiterTime改到FlightTask.cs中
         * 
        private int _FlytoTime = 10;
        public int FlytoTime
        {
            get { return _FlytoTime; }
            set { Set(nameof(FlytoTime), ref _FlytoTime, value); }
        }
        private int _LoiterTime = 0;
        public int LoiterTime
        {
            get { return _LoiterTime; }
            set { Set(nameof(LoiterTime), ref _LoiterTime, value); }
        }
        */



    }
}
